#ifndef MINIFAT_H
#define MINIFAT_H

#define MINIFAT_H

#include <vstypes.h>
#include "fat.h"

auto u_int16 FatGetByte(register __c0 u_int16 n);
auto u_int16 FatGetWord(register __c0 u_int16 n);
auto u_int32 FatGetLong(register __c0 u_int16 n);
auto u_int16 FatInitFileSystem(void);
auto __y struct FRAGMENT *FatFragmentList(
    register __i2 __y struct FRAGMENT *frag,
    register __reg_b u_int32 fatCluster);
auto s_int16 FatHandleDir(register __y struct FRAGMENT *curFragment,
			  __y struct FRAGMENT *nextFragment);
auto s_int16 FatOpenFile(register __c0 u_int16 fileNum);
auto s_int16 FatReadFile(register __i3 u_int16 *buf,
			 register __c1 s_int16 byteOff,
			 register __c0 s_int16 byteSize /*< <0 for little-endian order*/);
u_int32 FatTell(void);
u_int32 FatSeek(register __reg_a u_int32 pos); /*< returns old position */
void MemCopyPackedBigEndian(register __i0 u_int16 *dst,
			    register __a0 u_int16 dstidx,
			    register __i1 u_int16 *src,
			    register __a1 u_int16 srcidx,
			    register __b0 u_int16 byteSize);
void MemCopyPackedLittleEndian(register __i0 u_int16 *dst,
			       register __a0 u_int16 dstidx,
			       register __i1 u_int16 *src,
			       register __a1 u_int16 srcidx,
			       register __b0 u_int16 byteSize);
void MemWritePacked(register __a0 void *dst, register __a1 u_int16 dstidx,
		    register __b0 u_int16 dat);
u_int16 MemReadPacked(register __a0 const void *src,
		      register __a1 u_int16 srcidx);
void MemWritePackedY(register __a0 __y void *dst, register __a1 u_int16 dstidx,
		    register __b0 u_int16 dat);
u_int16 MemReadPackedY(register __a0 __y const void *src,
		      register __a1 u_int16 srcidx);

typedef s_int16 (*freeSectorCallback)(void *private, u_int32 sector, u_int32 numSecs);
s_int16 FatIterateOverFreeSectors(freeSectorCallback callBackFunction,
				  void *private);

auto u_int16 ReadDiskSector(register __i0 u_int16 *buffer,
			    register __reg_a u_int32 sector);

/**
   Minifat interface:
   - ReadDiskSector() must be provided

 */


#endif/*MINIFAT_H*/
