#ifndef __PLAYER_H__
#define __PLAYER_H__

#include <vstypes.h>

void putch(register __a0 short dat);

extern s_int16 tmpBuf[2*32];

extern struct Player {
    s_int16 totalFiles;
    s_int16 currentFile;
    s_int16 nextFile;
    s_int16 nextStep; /* 1 = next file, -1 = previous file */
    s_int16 pauseOn;
    s_int16 randomOn;
    s_int16 volume;
    s_int16 volumeOffset;
} player;

#if 0
/** Codec error codes. */
enum CodecError {
  ceFastForward = -1,	/**< Fast forwarded through file end */
  ceOk = 0,		/**< No errors. */
  ceFormatNotFound,	/**< Data file was not in known format for the codec */
  ceFormatNotSupported,	/**< Data file subformat is not supported. */
  ceUnexpectedFileEnd,	/**< Unexpectedly early end of file */
  ceCancelled,		/**< Playback cancel was requested */
  ceOtherError		/**< Unspecific error */
};
#endif


#define LED1 4 //SI
#define LED2 8 //SO

struct KeyMapping {
  u_int16 key;
  enum keyEvent event;
};
extern const struct KeyMapping *currentKeyMap;

#define KEY_1 1 /* prev/vol down     -> vol down 1 / vol down */
#define KEY_2 2 /* random/earspeaker -> vol up 1   / vol up */
#define KEY_3 4 /* next/vol up       -> prev / rew */
#define KEY_4 8 /*                   -> next / ff */
#define KEY_5 16 /*                  -> earspeaker / random */
#define KEY_POWER 256 /* pause / power off/on */
#define KEY_LONG_PRESS 0x8000
#define KEY_LONG_ONESHOT 0x8000

enum keyEvent {
  ke_null = 0,
  ke_previous,
  ke_next,
  ke_rewind,
  ke_forward,
  ke_volumeUp,
  ke_volumeDown,
  ke_earSpeaker, /* 0, 16000U, 38000U, 54000U */
  ke_earSpeakerToggle, /* 0, 38000U */
  ke_randomToggle,
  ke_randomToggleNewSong,
  ke_pauseToggle,
  ke_powerOff,
};




extern u_int16 keyOld, keyOldTime;
#define SHORT_LIMIT 16
#define OFF_LIMIT 32


extern __y u_int16 mallocAreaY[]; /* for ramdisk */
extern u_int16 mallocAreaX[];     /* for ramboot */

extern u_int32 supportedFiles; //TODO: BUG! FIX! Should be pointer!
extern const u_int32 defSupportedFiles[];


/*
  Function Prototypes
 */

void PlayerVolume(void);
auto u_int16 USBIsAttached(void);
auto void MassStorage(void);
void KeyEventHandler(enum keyEvent event);
auto u_int16 ReadGPIO(void);


#endif /*__PLAYER_H__*/
