#ifndef USB_H
#define USB_H

#define DT_LANGUAGES 0
#define DT_VENDOR 1
#define DT_MODEL 2
#define DT_SERIAL 3
#define DT_DEVICE 4
#define DT_CONFIGURATION 5
typedef struct usbpkt {
  u_int16 length;
  u_int16 payload[256];
} USBPacket;
extern struct USBVARS {
  const u_int16 *descriptorTable[6];
  u_int16 configurationDescriptorSize;
  USBPacket pkt;
  u_int32 totbytes;
  u_int16 ExtraZeroLengthPacketNeeded[4];
  const u_int16 *XmitBuf[4];
  u_int16 XmitLength[4];
  u_int16 EPReady[4];
  u_int16 lastSofTimeout;
  u_int16 configuration;
  u_int16 interfaces;
} USB;
int USBStartTransmission(u_int16 ep, const void *buf, 
			 u_int16 length, u_int16 requestedLength);
void USBContinueTransmission(u_int16 ep);
void USBSingleStallEndpoint(register __c0 u_int16 ep);
void InitUSB(u_int16 initDescriptors);
void USBResetEndpoint(register __c0 int ep);
u_int16 USBPacketReady();
u_int16 USBReceivePacket(USBPacket *packet);
void USBSendZeroLengthPacketToEndpoint(u_int16 endpoint);
void USBHandler();
u_int16 USBCheckForSetupPacket(void);
u_int16 USBXmitLeft(u_int16 endpoint);
void USBStallEndpoint(register __c0 int ep);
u_int16 SwapWord(register __a1 u_int16 d);
auto u_int16 USBIsAttached(void);
auto u_int16 USBIsDetached(void);
void MSCPacketFromPC(USBPacket *setupPacket);
u_int16 MscSendCsw(u_int16 status);
void DiskProtocolError(char errorcode);
void DecodeSetupPacket(void);
void RealDecodeSetupPacket(void);



#endif

